package filters;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;


public class StringResponseWrapper extends HttpServletResponseWrapper {

  // Strumien do ktrego bd pisane odpowiedzi
  private StringWriter stringWriter = null;

  public StringResponseWrapper(HttpServletResponse response) {
    super(response);
  }

  // Przedefiniowanie metody getWriter()
  // kady kto ejj uyje - otrzyma nasz strumie StringWriter
  // i nic o tym nie wiedzc bdzie pisa do niego
  // a nie do strumienia
  // zwizanego z oryginalnym obiektem HttpServletResponse


  public PrintWriter getWriter() throws IOException {
    if (stringWriter == null) stringWriter = new StringWriter();
    return new PrintWriter(stringWriter);
  }

  // Nie jestemy przygotowani na obsug strumieni binarnych
  // - wykluczamy ich zastosowanie (chocia nie musimy tego robi)

  public ServletOutputStream getOutputStream() throws IOException {
    throw new IllegalStateException(
      "getOutputStream() not allowed for StringResponseWrapper"
      );
  }

  // Nasza wasna metoda, pozwlajca uzyska dostp do strumioenia
  // i do jego zawartoci

  public StringWriter getStringWriter() {
    return stringWriter;
  }

}

